/**
  ******************************************************************************
  * ļ  system_init.c
  *     ChipON_AE/FAE_Group
  *     V2.61
  *     2019-11-16
  *     ļṩʱϵͳʱӳʼ
  *
  ******************************************************************************
  */
#include "system_init.h"

static unsigned int systick_us;
static unsigned int systick_ms;

/**
  *   ʱĬá
  *   ޡ
  *   ޡ
*/
static void SetSysClock(void)
{
	/* ʹڲƵʱ*/
	OSC_INTHF_Software_Enable(TRUE);
	while(OSC_Get_INTHF_INT_Flag() != SET);
	/* PLLʱԴѡ */
#ifdef SYSCLK_FREQ_HSI
	OSC_PLL_Input_Source_Config(PLL_INPUT_INTHF);
#else
	OSC_PLL_Input_Source_Config(PLL_INPUT_EXTHF);
#endif
	/* PLLƵʱѡ */
#ifdef SYSCLK_FREQ_48MHz
	OSC_PLL_Multiple_Value_Select(48,2,8);
#elif defined SYSCLK_FREQ_64MHz
	OSC_PLL_Multiple_Value_Select(32,2,4);
#elif defined SYSCLK_FREQ_72MHz
	OSC_PLL_Multiple_Value_Select(36,2,4);
#elif defined SYSCLK_FREQ_96MHz
	OSC_PLL_Multiple_Value_Select(12,1,2);
#elif defined SYSCLK_FREQ_120MHz
	OSC_PLL_Multiple_Value_Select(30,2,2);
#endif
	OSC_PLL_Start_Delay_Config(PLL_START_DELAY_1024);
	OSC_PLL_Software_Enable(TRUE);
	OSC_PLL_RST();
	while(OSC_Get_PLL_INT_Flag() != SET);
	/* ʱ */
	OSC_SCK_Division_Config(SCLK_DIVISION_1);
	OSC_SCK_Source_Config(SCLK_SOURCE_PLL);
	/* ʱ */
	OSC_HFCK_Division_Config(HFCK_DIVISION_1);
	OSC_HFCK_Source_Config(HFCK_SOURCE_INTHF);
	OSC_HFCK_Enable(TRUE);
}

/**
  *   ϵͳʼ
  *   ޡ
  *   ޡ
*/
void SystemInit(void)
{
	/* ʱ */
	SetSysClock();
	FLASH_CFG=0xC3;//FLASHȡ4
}
/**
  *   systick_delayʼ
  *   ޡ
  *   ޡ
*/
void systick_delay_init()
{
	ST_CTL&=0xFFFFFFFC;//ֹĶʱ,ж
	ST_RELOAD=0xFFFFFFFF;//ؼ
	ST_CV=0;//ǰ
	ST_CTL|=0x00000004;//SCLKʱ
#ifdef SYSCLK_FREQ_48MHz
	systick_us=48;
#elif defined SYSCLK_FREQ_72MHz
	systick_us=72;
#elif defined SYSCLK_FREQ_96MHz
	systick_us=96;
#elif defined SYSCLK_FREQ_120MHz
	systick_us=120;
#endif
    systick_ms=systick_us*1000;
}
/**
  *   usʱ
  *   nus
  *   
*/
void systick_delay_us(unsigned int nus)
{
	unsigned int temp;

	ST_RELOAD=systick_us*nus;//
	ST_CV=0;//ǰ0
	ST_CTL|=0x00000001;//ʹܽĶʱ
	do
	{
		temp=ST_CTL;
	}while((temp&0x01)&&!(temp&(1<<16)));	//ȴʱ䵽
	ST_CTL&=0xFFFFFFFE;//ֹĶʱ
}

/**
  *   msʱ
  *   mus
  *   
*/
void systick_delay_ms(unsigned int mus)
{
	unsigned int temp;

	ST_RELOAD=systick_ms*mus;//
	ST_CV=0;//ǰ0
	ST_CTL|=0x00000001;//ʹܽĶʱ
	do
	{
		temp=ST_CTL;
	}while((temp&0x01)&&!(temp&(1<<16)));	//ȴʱ䵽
	ST_CTL&=0xFFFFFFFE;//ֹĶʱ
}
